package com.jasamedika.medifirst2000.converter;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.springframework.stereotype.Component;

import com.google.gson.Gson;
import com.jasamedika.medifirst2000.converter.base.BaseVoConverter;
import com.jasamedika.medifirst2000.entities.PraAnestesiDokterBedah;
import com.jasamedika.medifirst2000.vo.PraAnestesiDokterBedahVO;

@Component
public class PraAnestesiDokterBedahConverter implements BaseVoConverter<PraAnestesiDokterBedahVO, PraAnestesiDokterBedah> {
	@Override
	public PraAnestesiDokterBedah transferVOToModel(PraAnestesiDokterBedahVO vo, PraAnestesiDokterBedah model) {
		if (null == model)
			model = new PraAnestesiDokterBedah();
		try {
			String[] fieldsToInclude = null;
			Map<String, Object> serialized = vo.serialize(fieldsToInclude,vo.getClass().getName());
			Gson gson = new Gson();
	        String json = gson.toJson(serialized);
	        model = gson.fromJson(json, PraAnestesiDokterBedah.class);
		} catch (Exception e) {
			e.printStackTrace();
		}

		return model;
	}

	@Override
	public List<PraAnestesiDokterBedahVO> transferListOfModelToListOfVO(List<PraAnestesiDokterBedah> models, List<PraAnestesiDokterBedahVO> vos) {

		if (null == vos)
			vos = new ArrayList<PraAnestesiDokterBedahVO>();

		if (null == models)
			return vos;

		for (PraAnestesiDokterBedah praAnestesiDokterBedah : models) {
			PraAnestesiDokterBedahVO vo = new PraAnestesiDokterBedahVO();
			vo=transferModelToVO(praAnestesiDokterBedah, vo);
			vos.add(vo);
		}

		return vos;
	}

	@Override
	public PraAnestesiDokterBedahVO transferModelToVO(PraAnestesiDokterBedah model, PraAnestesiDokterBedahVO vo) {
		if (null == vo)
			vo = new PraAnestesiDokterBedahVO();
		try {
			String[] fieldsToInclude = null;
			Map<String, Object> serialized = model.serialize(fieldsToInclude,model.getClass().getSimpleName());
			Gson gson = new Gson();
	        String json = gson.toJson(serialized);
	        vo = gson.fromJson(json, PraAnestesiDokterBedahVO.class);
		} catch (Exception e) {
			e.printStackTrace();
		}

		return vo;
	}
	
	public PraAnestesiDokterBedahVO transferModelToVOCustom(PraAnestesiDokterBedah model, PraAnestesiDokterBedahVO vo,String[] fieldsToInclude) {
		if (null == vo)

		vo = new PraAnestesiDokterBedahVO();

		try {
			Map<String, Object> serialized = model.serialize(fieldsToInclude,model.getClass().getSimpleName());
			Gson gson = new Gson();
	        String json = gson.toJson(serialized);
	        vo = gson.fromJson(json, PraAnestesiDokterBedahVO.class);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return vo;
	}
}
